/***************************************************************************
 *   Copyright (C) 2005 by Bruno Baert   *
 *   baertbruno@gmail.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream>
#include <cstdlib>

#include <GL/glut.h>
#include <GL/gl.h>
#include "memory.h"
#include "stdio.h"
#include "stdlib.h"
#include "time.h"
#include "math.h"

#include "SnowFlakes.h"


#define FL (float)
#define PI FL(3.1415926535897932384626)

using namespace std;

Neige* manege;

// float speed= 0.038;
float speed= 0.038;
int lastFrameTime = 0;

int width, height;

char ligne[28];

float r=0.7,g=0.5,b=0.0;

bool help = false;
int lw = 2;

int t=0;
int u = 0;

bool *flocons;

void print_stroke_string(void* font, char* s)
{
   if (s && strlen(s)) {
      while (*s) {
         glutStrokeCharacter(font, *s);
         s++;
      }
   }
}

void print_bitmap_string(void* font, char* s)
{
   if (s && strlen(s)) {
      while (*s) {
         glutBitmapCharacter(font, *s);
         s++;
      }
   }
}



void* stroke_fonts[2] = {
	GLUT_STROKE_ROMAN,
	GLUT_STROKE_MONO_ROMAN
};

   #define EXIT        {fclose(fichier); return -1;}
    #define CTOI(C)     (*(int*)&C)
        
    GLuint  TexNum[1];
 
//------------------------------------------------------------------------------
// Charge une image BMP 24 bits
//------------------------------------------------------------------------------

int LoadBMP(char *filename, int nb)
 {
    printf("c bon ici 1\n");
    GLubyte     *image;
    GLubyte     Header[0x36];
    GLuint      DataPos, imageSize;
    GLsizei     Width,Height;
    int         i;
    
    // Lit le fichier et son header
    FILE * fichier = fopen(filename,"rb");
    if (!fichier) return -1;
    if (fread(Header,1,0x36,fichier)!=0x36) EXIT;
    if (Header[0]!='B' || Header[1]!='M')   EXIT;
    if (CTOI(Header[0x1E])!=0)              EXIT;
    if (CTOI(Header[0x1C])!=24)             EXIT;
    printf("c bon ici 2\n");
    // Rcupre les infos de l'image
    Width   = CTOI(Header[0x12]);
    Height  = CTOI(Header[0x16]);
    ( CTOI(Header[0x0A]) == 0 ) ? ( DataPos=0x36 ) : ( DataPos = CTOI(Header[0x0A]) );
    ( CTOI(Header[0x22]) == 0 ) ? ( imageSize=Width*Height*3 ) : ( DataPos = CTOI(Header[0x22]) );        

    // Charge l'image
    image = (GLubyte *) malloc ( imageSize );
    printf("c bon ici 3\n");
    if (fread(image,1,imageSize,fichier)!=imageSize) 
     {
     printf("c bon ici 4\n");
        free (image);
        EXIT;
     }

    // Inverse R et B
    for ( i = 0; i < imageSize; i += 3 )
     {
        int t = image[i];
        image[i] = image[i+2];
        image[i+2] = t;
     }

    // Traitements de la texture par OpenGL
    glPixelStorei(GL_UNPACK_ALIGNMENT,1);        // Construit la texture sous forme de donnes
    glGenTextures(nb, &TexNum[nb]);              // Gnre une ID pour la texture OpenGL                                             
    
    glBindTexture(GL_TEXTURE_2D, TexNum[nb]);    // Pointe la texture
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);

    // Gnre la texture OpenGL en mmoire
    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, Width, Height, 0, GL_RGB, GL_UNSIGNED_BYTE, image);

    fclose (fichier);
    free (image);
    return TexNum[nb];
 }


void MoveFlakes()
{
	for(int c = 0; c < width;c++)
			for(int d=0; d<height; d++)
				if(flocons[c*height+d])
				{
					flocons[(c+rand()%3 -1)*height+d-1] = true;
					flocons[c*height+d] = false;
				}
}


void HELP()
{
	glTranslatef( 0.0f, 0.0f, 0.0f );
	glLoadIdentity();
 	glRotatef( 0.0, 1.0f, 1.0f, 0.0f );
	glColor3f(0.0,0.0,0.38);
	glBegin(GL_QUADS);
	glVertex3f(-0.98, -0.50, 0.0);
	glVertex3f(-0.98,  0.50, 0.0);
	glVertex3f( 0.98,  0.50, 0.0);
	glVertex3f( 0.98, -0.50, 0.0);
	glEnd();
	
	
	glColor3f(1.0,1.0,0.0);
	glBegin(GL_LINE_STRIP);
	glVertex3f(-0.98, -0.50, 0.0);
	glVertex3f(-0.98,  0.50, 0.0);
	glVertex3f( 0.98,  0.50, 0.0);
	glVertex3f( 0.98, -0.50, 0.0);
	glVertex3f(-0.98, -0.50, 0.0);
	glEnd();
	sprintf(ligne, "Commandes :");
	glRasterPos2f(-0.85, 0.40);
	print_bitmap_string(GLUT_BITMAP_9_BY_15, ligne);
	sprintf(ligne, "-----------");
	glRasterPos2f(-0.85, 0.37);
	print_bitmap_string(GLUT_BITMAP_9_BY_15, ligne);
	sprintf(ligne, "W: diminuer frequence 1             X: augmenter frequence 1");
	glRasterPos2f(-0.85, 0.30);
	print_bitmap_string(GLUT_BITMAP_9_BY_15, ligne);
	sprintf(ligne, "C: diminuer frequence 2             V: augmenter frequence 2");
	glRasterPos2f(-0.85, 0.25);
	print_bitmap_string(GLUT_BITMAP_9_BY_15, ligne);
	sprintf(ligne, "B: diminuer frequence 3             N: augmenter frequence 3");
	glRasterPos2f(-0.85, 0.2);
	print_bitmap_string(GLUT_BITMAP_9_BY_15, ligne);

	
	sprintf(ligne, "F: Diminuer la phase 1              G: Augmenter la phase 1");
	glRasterPos2f(-0.85, 0.1);
	print_bitmap_string(GLUT_BITMAP_9_BY_15, ligne);
	sprintf(ligne, "J: Diminuer la phase 2              K: Augmenter la phase 2");
	glRasterPos2f(-0.85, 0.05);
	print_bitmap_string(GLUT_BITMAP_9_BY_15, ligne);
	
	sprintf(ligne, "P: cacher/afficher le curseur       L: changer l'epaisseur du trace");
	glRasterPos2f(-0.85, -0.05);
	print_bitmap_string(GLUT_BITMAP_9_BY_15, ligne);
	sprintf(ligne, "R: Recommencer le trace             D: changement entre 2D et 3D");
	glRasterPos2f(-0.85, -0.1);
	print_bitmap_string(GLUT_BITMAP_9_BY_15, ligne);
	sprintf(ligne, "O: afficher/cacher les equations    ESC: quitter le programme");
	glRasterPos2f(-0.85, -0.15);
	print_bitmap_string(GLUT_BITMAP_9_BY_15, ligne);
	sprintf(ligne, "Pour changer la couleur: taper 'Z' suivi de la couleur:");
	glRasterPos2f(-0.85, -0.25);
	print_bitmap_string(GLUT_BITMAP_9_BY_15, ligne);
	sprintf(ligne, "  red - green - blue - yellow - orange");
	glRasterPos2f(-0.85, -0.32);
	print_bitmap_string(GLUT_BITMAP_9_BY_15, ligne);
	sprintf(ligne, "  white - purple - brown - pink");
	glRasterPos2f(-0.85, -0.37);
	print_bitmap_string(GLUT_BITMAP_9_BY_15, ligne);
	glColor3f(1.0,0.5,0.0);
	sprintf(ligne, "Appuyez a nouveau sur H pour quitter l'aide");
	glRasterPos2f(-0.85, -0.45);
	print_bitmap_string(GLUT_BITMAP_9_BY_15, ligne);


	glColor3f(1.0,1.0,1.0);


}

int caract;

void renderScene(void) {
	glutGet(GLUT_WINDOW_WIDTH);
	if(lastFrameTime == 0)
	{
			lastFrameTime = glutGet(GLUT_ELAPSED_TIME);
	}
	int now = glutGet(GLUT_ELAPSED_TIME);
	int elapsedMilliseconds = now - lastFrameTime;
	float elapsedTime = elapsedMilliseconds / 1000.0f;
	if(elapsedTime > speed)
	{
		glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
		
// 		glViewport(0, 0, 1.6, 1.0);
		glViewport(0, 0, width, height);
		glMatrixMode( GL_MODELVIEW );
		glDepthRange(-200.0, 200.0);		
		glColor3f(1.0,1.0,1.0);
		glPointSize(2);
		manege->Draw();
		manege->Fall();
		
/*		sprintf(ligne, "caractere tape: %d", caract);
		glRasterPos2f(-0.85, -0.45);
		print_bitmap_string(GLUT_BITMAP_9_BY_15, ligne);*/
		
		
		/*glPointSize(2);
		glBegin(GL_POINTS);
		for(int c = 0; c < width;c++)
			for(int d=0; d<height; d++)
				if(flocons[c*height+d])
					glVertex3f((float)(c-(width/2))/(float)width*2.0,(float)(d-(height/2))/float(height)*2.0,0.0);
		glEnd();
		
		MoveFlakes();*/
		
		if(help)
			HELP();
		glutSwapBuffers();
		glFlush();
		lastFrameTime = now;
	}
}


void keyboard(unsigned char key, int x, int y)
{
	if(key == 27)
	{
			{glutSetCursor(GLUT_CURSOR_RIGHT_ARROW); exit(1);}
	}
	switch (key)
	{
	case 'h':	help=!help; break;
	case 'r':	t=u=0; break;
	case 56:	Flakes::ModSpeed(1) ; break;
	case 50:	Flakes::ModSpeed(0); break;
	case 43:	manege->Add(5); break;
	case 45:	manege->Remove(5); break;
	}
// 	caract = key;
	
}	

int main(int argc, char *argv[])
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA | GLUT_ALPHA);
	width = glutGet(GLUT_SCREEN_WIDTH);
	height = glutGet(GLUT_SCREEN_HEIGHT);
	glutInitWindowPosition(100,100);
	glutInitWindowSize(width,height);
	glutCreateWindow("SnowFlakes . . .");
	
// 	glutGameModeString("1280x800:16@60");
	
 //	glutEnterGameMode();
	glutFullScreen();
	width = glutGet(GLUT_WINDOW_WIDTH);
	height = glutGet(GLUT_WINDOW_HEIGHT);
// 	flocons = (bool*)malloc(sizeof(bool)*width*height);

	manege = new Neige(150, glutGet(GLUT_WINDOW_WIDTH), glutGet(GLUT_WINDOW_HEIGHT), 0.01);
	
// 	LoadBMP ( "/home/Bretu/test.bmp", 0 );
	
	/*for(int b=0; b < width*height; b++)
		flocons[b] = false;
	for(int c=0; c < width*height/1000; c++)
	{
		flocons[(rand()%width)*height+rand()%height] = true;
	}*/
	glutDisplayFunc(renderScene);
	glutIdleFunc(renderScene);
	glutKeyboardFunc( keyboard );
	glutSetCursor(GLUT_CURSOR_NONE);
	glutMainLoop();
  return EXIT_SUCCESS;
}
